#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *

def plugin_select_is_new_circle(image, layer, autocrop, centered, resize, select):

	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
		
	parent = pdb.gimp_item_get_parent(layer)
	name = pdb.gimp_item_get_name(layer)
	position = pdb.gimp_image_get_item_position(image , layer)
	pdb.gimp_edit_copy(layer)
	copy = pdb.gimp_edit_paste(layer ,1)
	pdb.gimp_floating_sel_to_layer(copy)
	pdb.gimp_image_reorder_item(image ,copy ,parent ,position)
	pdb.gimp_item_set_visible(copy, 1)
	
	#pdb.plug_in_polar_coords(image, drawable, circle, angle, backwards, inverse, polrec)
	pdb.plug_in_polar_coords(image, copy, 100, 0, 1, 0, 0)
	pdb.plug_in_polar_coords(image, copy, 100, 0, 1, 1, 1)
	
	if autocrop==1:
		pdb.plug_in_autocrop_layer(image, copy)
	
	if centered==1:
		wi = pdb.gimp_image_width(image)
		hi = pdb.gimp_image_height(image)	
		wh = pdb.gimp_drawable_width(copy)
		hh = pdb.gimp_drawable_height(copy)
		centerx=wi/2
		centery=hi/2
		adw=wh/2
		adh=hh/2
		sw=centerx - adw
		sh=centery - adh		
		pdb.gimp_layer_set_offsets(copy, sw, sh)
		
	if resize==1:
		pdb.gimp_layer_resize_to_image_size(copy)
		
	if select==1:	
		pdb.gimp_selection_none(image)
		
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
  
register(
        "plugin_select_is_new_circle",
        "Selection (rectangle) to circle polar coords\n (from active to a new layer)",
        "Selection (in active layer) to circle polar coords",
        "MareroQ",
        "GPL",
        "2019",
        "<Image>/Select/Selection to circle polar coords...",
        "RGB*, GRAY*",
        [
		#	(PF_IMAGE, "image", "Input image", None),
		#	(PF_LAYER, "layer", "Input layer", None),
		(PF_BOOL, "autocrop", ("Autocrop? "), False),
		(PF_BOOL, "centered", ("Centered? "), False),
		(PF_BOOL, "resize", ("Resize to image size? "), False),
		(PF_BOOL, "select", ("Deselect ? "), False),		
		],
        [],
        plugin_select_is_new_circle)

main()

